
module Atatus
  module Collector
    class TxnHist
      def initialize(type, kind, duration)
        @type = type
        @kind = kind
        @hist = {}
        @hist[find_bin duration] = 1
      end

      attr_reader :type, :kind, :hist

      def aggregate!(duration)
        hbin = find_bin duration
        if !@hist.key?(hbin)
          @hist[hbin] = 1
        else
          @hist[hbin] += 1
        end
      end

      private
      def find_bin(duration)
        seconds = 1000
        hbin = 0

        if duration < 0
          hbin = 0
        elsif duration < 2*seconds
          hbin = round_bin(duration, 10)
        elsif duration < 10*seconds
          hbin = round_bin(duration, 25)
        elsif duration < 20*seconds
          hbin = round_bin(duration, 50)
        elsif duration < 50*seconds
          hbin = round_bin(duration, 100)
        elsif duration < 80*seconds
          hbin = round_bin(duration, 200)
        elsif duration < 100*seconds
          hbin = round_bin(duration, 250)
        else
          hbin = round_bin(duration, 1000)
        end

        hbin
      end

      def round_bin(duration, unit)
        ((duration / unit.to_f).floor) * unit
      end
    end
  end
end
