
module Atatus
  module Collector
    class Layer
      def initialize(type, kind, duration)
        @type = type
        @kind = kind
        @count = 1
        @min = duration
        @max = duration
        @total = duration
      end

      attr_reader :type, :kind, :count, :min, :max, :total
      attr_accessor :id, :pid

      def aggregate!(duration)
        @count += 1
        @min = duration if duration < @min
        @max = duration if duration > @max
        @total += duration
      end

      def self.span_kind(value)
        return KINDS.fetch(value, value)
      end

      def self.span_type(value)
        return TYPES.fetch(value, value)
      end

      private
      KINDS = {
        'db' => 'Database',
        'cache' => 'Database',
        'ext' => 'Remote',
        'websocket' => 'Remote',
        'template' => 'Template'
      }.freeze

      TYPES = {
        'mysql' => 'MySQL',
        'mysql2' => 'MySQL',
        'postgresql' => 'Postgres',
        'mssql' => 'MS SQL',
        'mongodb' => 'MongoDB',
        'redis' => 'Redis',
        'graphql' => 'GraphQL',
        'elasticsearch' => 'Elasticsearch',
        'cassandra' => 'Cassandra',
        'sqlite'=> 'SQLite',
        'controller' => 'Controller',
        'view' => 'View',
        'http' => 'External Requests',
        'http2' => 'External Requests',
        'http_rb' => 'External Requests',
        'net_http' => 'External Requests'
      }.freeze
    end
  end
end
