# frozen_string_literal: true

module Atatus
  class Metadata
    class SystemInfo
      # @api private
      class OSInfo
        attr_accessor :os, :kernel

        def initialize
        end

        def read!
          read_from_uname!
          self
        end

        def self.read!
          new.read!
        end

        private

        def read_from_uname!
          self.os = `uname -s`.strip.downcase!
          self.kernel = `uname -r`.strip
        end
      end
    end
  end
end
